--- Data Memory for the DHBW MCT controller (VHDL)

use work.MCT_Pack_uP.all;
library ieee;
use ieee.std_logic_1164.all;
use IEEE.numeric_std.all;

entity D_RAM is                 				 
	port ( Clk, DS_EN, RnW, SEL_PC_Akku : in std_logic; -- Clock, D_RAM Enable, ReadNotWrite     
		 RWADDR : in  DA_TYPE;      
		 DATIN, StackO  : in  D_TYPE;
		 DTOUT, StackI  : out D_TYPE);    	
end D_RAM;  
		
architecture RTL of D_RAM is
    
 -- array of 48 samples, each 8 bits wide (reduced for tests)
 type RAM_array is array(0 to 47) of D_TYPE;
		 
	-- instantiate memory object of X_RAM
	signal dmemory : RAM_array  := (
	       0 => "00000000",	-- 0
         1 => "00000000",	-- 0
         2 => "00000000", -- 0
	       others => x"00");   
  	
 begin       
 	-- read & write process 
	process (Clk) begin	
	  if (DS_EN = '1') then
	     if (rising_edge(Clk)) then
	       if (RnW = '0') then		      	-- write access
	         if (SEL_PC_Akku = '1') then    -- write PC to stack
	           dmemory(to_integer(unsigned(RWADDR))) <= StackO;
	         elsif (SEL_PC_Akku = '0') then -- write Akku
		         dmemory(to_integer(unsigned(RWADDR))) <= DATIN;
		       end if;
         elsif (RnW = '1') then 		   -- read access 
	         if (SEL_PC_Akku = '1') then    -- read PC from stack
             StackI <= dmemory(to_integer(unsigned(RWADDR)));
	         elsif (SEL_PC_Akku = '0') then -- read Akku
             DTOUT <= dmemory(to_integer(unsigned(RWADDR)));
		       end if;
         end if;
       end if;
    end if;
  end process;
    
end RTL;
