--- Program_Memory for the DHBW MCT controller (VHDL)
--- tested: SR 12.01.2015 ok
use work.MCT_Pack_uP.all;
library ieee;
use ieee.std_logic_1164.all;
use IEEE.numeric_std.all;

entity P_ROM is                 
	port ( Clk, Pipe_EN : in std_logic; -- Clock
		     PADDR : in  PA_TYPE; PDOUT : out P_TYPE);    	
end P_ROM;  
		
architecture RTL of P_ROM is
    
 -- array of 2**8 samples, each 16 bits wide (reduced for tests)
 type ROM_array is array(0 to 32) of P_TYPE;
		 
	-- instantiate memory object with sample program
	signal pmemory : ROM_array   := (
         0 => "0001100000001000", -- LDI 1
         1 => "0010100000000010", -- STR $1
         2 => "0001100000111000", -- LDI 7
         3 => "1000000000001100", -- CALL Count (Zeile 12)
         4 => "0000000000000000",	-- NOP   
         5 => "1000000000001100", -- CALL Count (Zeile 12)
         6 => "0000000000000000",	-- NOP  
         7 => "1000000000001100", -- CALL Count (Zeile 12)
         8 => "0000000000000000",	-- NOP  
         9 => "0000000000000000",	-- NOP  
        10 => "0000000000000000",	-- NOP  
        11 => "0000000000000000",	-- NOP  
        12 => "0111000000000000", -- PUSH
        13 => "0001100000001000", -- LDI 1
        14 => "0011000000000010",	-- ADD $1 
        15 => "0010100000000010", -- STR $1 
        16 => "0111100000000000", -- POP  
        17 => "1000100000000000", -- RET    
	      others => "0000000000000000");  

 begin       
 	-- read process 
	process (Clk, Pipe_EN) begin	
	  if (Pipe_EN = '1') then
	    if (rising_edge(Clk)) then
       PDOUT <= pmemory(to_integer(unsigned(PADDR)));
      end if;
    end if;
  end process;
    
end RTL;